

# Actions
<a name="API_Operations"></a>

The following actions are supported:
+  [AcceptResourceGroupingRecommendations](API_AcceptResourceGroupingRecommendations.md) 
+  [AddDraftAppVersionResourceMappings](API_AddDraftAppVersionResourceMappings.md) 
+  [BatchUpdateRecommendationStatus](API_BatchUpdateRecommendationStatus.md) 
+  [CreateApp](API_CreateApp.md) 
+  [CreateAppVersionAppComponent](API_CreateAppVersionAppComponent.md) 
+  [CreateAppVersionResource](API_CreateAppVersionResource.md) 
+  [CreateRecommendationTemplate](API_CreateRecommendationTemplate.md) 
+  [CreateResiliencyPolicy](API_CreateResiliencyPolicy.md) 
+  [DeleteApp](API_DeleteApp.md) 
+  [DeleteAppAssessment](API_DeleteAppAssessment.md) 
+  [DeleteAppInputSource](API_DeleteAppInputSource.md) 
+  [DeleteAppVersionAppComponent](API_DeleteAppVersionAppComponent.md) 
+  [DeleteAppVersionResource](API_DeleteAppVersionResource.md) 
+  [DeleteRecommendationTemplate](API_DeleteRecommendationTemplate.md) 
+  [DeleteResiliencyPolicy](API_DeleteResiliencyPolicy.md) 
+  [DescribeApp](API_DescribeApp.md) 
+  [DescribeAppAssessment](API_DescribeAppAssessment.md) 
+  [DescribeAppVersion](API_DescribeAppVersion.md) 
+  [DescribeAppVersionAppComponent](API_DescribeAppVersionAppComponent.md) 
+  [DescribeAppVersionResource](API_DescribeAppVersionResource.md) 
+  [DescribeAppVersionResourcesResolutionStatus](API_DescribeAppVersionResourcesResolutionStatus.md) 
+  [DescribeAppVersionTemplate](API_DescribeAppVersionTemplate.md) 
+  [DescribeDraftAppVersionResourcesImportStatus](API_DescribeDraftAppVersionResourcesImportStatus.md) 
+  [DescribeMetricsExport](API_DescribeMetricsExport.md) 
+  [DescribeResiliencyPolicy](API_DescribeResiliencyPolicy.md) 
+  [DescribeResourceGroupingRecommendationTask](API_DescribeResourceGroupingRecommendationTask.md) 
+  [ImportResourcesToDraftAppVersion](API_ImportResourcesToDraftAppVersion.md) 
+  [ListAlarmRecommendations](API_ListAlarmRecommendations.md) 
+  [ListAppAssessmentComplianceDrifts](API_ListAppAssessmentComplianceDrifts.md) 
+  [ListAppAssessmentResourceDrifts](API_ListAppAssessmentResourceDrifts.md) 
+  [ListAppAssessments](API_ListAppAssessments.md) 
+  [ListAppComponentCompliances](API_ListAppComponentCompliances.md) 
+  [ListAppComponentRecommendations](API_ListAppComponentRecommendations.md) 
+  [ListAppInputSources](API_ListAppInputSources.md) 
+  [ListApps](API_ListApps.md) 
+  [ListAppVersionAppComponents](API_ListAppVersionAppComponents.md) 
+  [ListAppVersionResourceMappings](API_ListAppVersionResourceMappings.md) 
+  [ListAppVersionResources](API_ListAppVersionResources.md) 
+  [ListAppVersions](API_ListAppVersions.md) 
+  [ListMetrics](API_ListMetrics.md) 
+  [ListRecommendationTemplates](API_ListRecommendationTemplates.md) 
+  [ListResiliencyPolicies](API_ListResiliencyPolicies.md) 
+  [ListResourceGroupingRecommendations](API_ListResourceGroupingRecommendations.md) 
+  [ListSopRecommendations](API_ListSopRecommendations.md) 
+  [ListSuggestedResiliencyPolicies](API_ListSuggestedResiliencyPolicies.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [ListTestRecommendations](API_ListTestRecommendations.md) 
+  [ListUnsupportedAppVersionResources](API_ListUnsupportedAppVersionResources.md) 
+  [PublishAppVersion](API_PublishAppVersion.md) 
+  [PutDraftAppVersionTemplate](API_PutDraftAppVersionTemplate.md) 
+  [RejectResourceGroupingRecommendations](API_RejectResourceGroupingRecommendations.md) 
+  [RemoveDraftAppVersionResourceMappings](API_RemoveDraftAppVersionResourceMappings.md) 
+  [ResolveAppVersionResources](API_ResolveAppVersionResources.md) 
+  [StartAppAssessment](API_StartAppAssessment.md) 
+  [StartMetricsExport](API_StartMetricsExport.md) 
+  [StartResourceGroupingRecommendationTask](API_StartResourceGroupingRecommendationTask.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateApp](API_UpdateApp.md) 
+  [UpdateAppVersion](API_UpdateAppVersion.md) 
+  [UpdateAppVersionAppComponent](API_UpdateAppVersionAppComponent.md) 
+  [UpdateAppVersionResource](API_UpdateAppVersionResource.md) 
+  [UpdateResiliencyPolicy](API_UpdateResiliencyPolicy.md) 

# AcceptResourceGroupingRecommendations
<a name="API_AcceptResourceGroupingRecommendations"></a>

Accepts the resource grouping recommendations suggested by AWS Resilience Hub for your application.

## Request Syntax
<a name="API_AcceptResourceGroupingRecommendations_RequestSyntax"></a>

```
POST /accept-resource-grouping-recommendations HTTP/1.1
Content-type: application/json

{
   "appArn": "string",
   "entries": [ 
      { 
         "groupingRecommendationId": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_AcceptResourceGroupingRecommendations_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_AcceptResourceGroupingRecommendations_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [appArn](#API_AcceptResourceGroupingRecommendations_RequestSyntax) **   <a name="resiliencehub-AcceptResourceGroupingRecommendations-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [entries](#API_AcceptResourceGroupingRecommendations_RequestSyntax) **   <a name="resiliencehub-AcceptResourceGroupingRecommendations-request-entries"></a>
List of resource grouping recommendations you want to include in your application.  
Type: Array of [AcceptGroupingRecommendationEntry](API_AcceptGroupingRecommendationEntry.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 30 items.  
Required: Yes

## Response Syntax
<a name="API_AcceptResourceGroupingRecommendations_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string",
   "failedEntries": [ 
      { 
         "errorMessage": "string",
         "groupingRecommendationId": "string"
      }
   ]
}
```

## Response Elements
<a name="API_AcceptResourceGroupingRecommendations_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_AcceptResourceGroupingRecommendations_ResponseSyntax) **   <a name="resiliencehub-AcceptResourceGroupingRecommendations-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [failedEntries](#API_AcceptResourceGroupingRecommendations_ResponseSyntax) **   <a name="resiliencehub-AcceptResourceGroupingRecommendations-response-failedEntries"></a>
List of resource grouping recommendations that could not be included in your application.  
Type: Array of [FailedGroupingRecommendationEntry](API_FailedGroupingRecommendationEntry.md) objects

## Errors
<a name="API_AcceptResourceGroupingRecommendations_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_AcceptResourceGroupingRecommendations_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/AcceptResourceGroupingRecommendations) 

# AddDraftAppVersionResourceMappings
<a name="API_AddDraftAppVersionResourceMappings"></a>

Adds the source of resource-maps to the draft version of an application. During assessment, AWS Resilience Hub will use these resource-maps to resolve the latest physical ID for each resource in the application template. For more information about different types of resources supported by AWS Resilience Hub and how to add them in your application, see [Step 2: How is your application managed?](https://docs.aws.amazon.com/resilience-hub/latest/userguide/how-app-manage.html) in the AWS Resilience Hub User Guide.

## Request Syntax
<a name="API_AddDraftAppVersionResourceMappings_RequestSyntax"></a>

```
POST /add-draft-app-version-resource-mappings HTTP/1.1
Content-type: application/json

{
   "appArn": "string",
   "resourceMappings": [ 
      { 
         "appRegistryAppName": "string",
         "eksSourceName": "string",
         "logicalStackName": "string",
         "mappingType": "string",
         "physicalResourceId": { 
            "awsAccountId": "string",
            "awsRegion": "string",
            "identifier": "string",
            "type": "string"
         },
         "resourceGroupName": "string",
         "resourceName": "string",
         "terraformSourceName": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_AddDraftAppVersionResourceMappings_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_AddDraftAppVersionResourceMappings_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [appArn](#API_AddDraftAppVersionResourceMappings_RequestSyntax) **   <a name="resiliencehub-AddDraftAppVersionResourceMappings-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [resourceMappings](#API_AddDraftAppVersionResourceMappings_RequestSyntax) **   <a name="resiliencehub-AddDraftAppVersionResourceMappings-request-resourceMappings"></a>
Mappings used to map logical resources from the template to physical resources. You can use the mapping type `CFN_STACK` if the application template uses a logical stack name. Or you can map individual resources by using the mapping type `RESOURCE`. We recommend using the mapping type `CFN_STACK` if the application is backed by a CloudFormation stack.  
Type: Array of [ResourceMapping](API_ResourceMapping.md) objects  
Required: Yes

## Response Syntax
<a name="API_AddDraftAppVersionResourceMappings_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string",
   "appVersion": "string",
   "resourceMappings": [ 
      { 
         "appRegistryAppName": "string",
         "eksSourceName": "string",
         "logicalStackName": "string",
         "mappingType": "string",
         "physicalResourceId": { 
            "awsAccountId": "string",
            "awsRegion": "string",
            "identifier": "string",
            "type": "string"
         },
         "resourceGroupName": "string",
         "resourceName": "string",
         "terraformSourceName": "string"
      }
   ]
}
```

## Response Elements
<a name="API_AddDraftAppVersionResourceMappings_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_AddDraftAppVersionResourceMappings_ResponseSyntax) **   <a name="resiliencehub-AddDraftAppVersionResourceMappings-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [appVersion](#API_AddDraftAppVersionResourceMappings_ResponseSyntax) **   <a name="resiliencehub-AddDraftAppVersionResourceMappings-response-appVersion"></a>
The version of the application.  
Type: String  
Pattern: `\S{1,50}` 

 ** [resourceMappings](#API_AddDraftAppVersionResourceMappings_ResponseSyntax) **   <a name="resiliencehub-AddDraftAppVersionResourceMappings-response-resourceMappings"></a>
List of sources that are used to map a logical resource from the template to a physical resource. You can use sources such as AWS CloudFormation, Terraform state files, AppRegistry applications, or Amazon EKS.  
Type: Array of [ResourceMapping](API_ResourceMapping.md) objects

## Errors
<a name="API_AddDraftAppVersionResourceMappings_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## Examples
<a name="API_AddDraftAppVersionResourceMappings_Examples"></a>

### Example CloudFormation Request
<a name="API_AddDraftAppVersionResourceMappings_Example_1"></a>

The following is an example request payload.

#### Sample Request
<a name="API_AddDraftAppVersionResourceMappings_Example_1_Request"></a>

```
{
  "appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/dd058443-7e2f-410d-bee6-c634cb3edb39",
  "resourceMappings": [
    {
      "logicalStackName": "my-stack-name",
      "mappingType": "CfnStack",
      "physicalResourceId": {
        "identifier": "arn:aws:cloudformation:us-west-2:444455556666:stack/my-stack-name/fe0e1e00-03eb-11ee-8796-02038f8a9691",
        "type": "Arn"
      }
    }
  ]
}
```

### Sample CloudFormation Response
<a name="API_AddDraftAppVersionResourceMappings_Example_2"></a>

The following is an example response payload.

#### Sample Response
<a name="API_AddDraftAppVersionResourceMappings_Example_2_Response"></a>

```
{
  "appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/dd058443-7e2f-410d-bee6-c634cb3edb39",
  "appVersion": "draft",
  "resourceMappings": [
    {
      "logicalStackName": "my-stack-name",
      "mappingType": "CfnStack",
      "physicalResourceId": {
        "identifier": "arn:aws:cloudformation:us-west-2:444455556666:stack/my-stack-name/fe0e1e00-03eb-11ee-8796-02038f8a9691",
        "type": "Arn"
      }
    }
  ]
}
```

### Example Terraform Request
<a name="API_AddDraftAppVersionResourceMappings_Example_3"></a>

The following is an example request payload.

#### Sample Request
<a name="API_AddDraftAppVersionResourceMappings_Example_3_Request"></a>

```
{
"appArn": " arn:aws:resiliencehub:us-west-2:444455556666:app/4019253a-0c99-4d30-be32-b14dd46d1c3d",
   "resourceMappings": [ 
      {
"mappingType": "Terraform",
         "physicalResourceId": {
            "awsAccountId": "444455556666",
            "awsRegion": "us-west-2",
            "identifier": "s3://my-terraform-bucket/my/path/application-state-file.tfstate",
            "type": "Native"
         }, 
          
      }
   ]
}
```

### Sample Terraform Response
<a name="API_AddDraftAppVersionResourceMappings_Example_4"></a>

The following is an example response payload.

#### Sample Response
<a name="API_AddDraftAppVersionResourceMappings_Example_4_Response"></a>

```
{
  "appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/4019253a-0c99-4d30-be32-b14dd46d1c3d",
  "resourceMappings": [
    {
      "terraformSourceName": "application-state-file.tfstate",
      "mappingType": "Terraform",
      "physicalResourceId": {
        "identifier": "s3://terraform-bucket/web-app/latest/application-state-file.tfstate",
        "type": "Native",
        "awsRegion": "us-west-2",
        "awsAccountId": "444455556666"
      }
    }
  ]
}
```

### Sample AppRegistry Request
<a name="API_AddDraftAppVersionResourceMappings_Example_5"></a>

The following is an example request payload.

#### Sample Request
<a name="API_AddDraftAppVersionResourceMappings_Example_5_Request"></a>

```
{
"appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/4019253a-0c99-4d30-be32-b14dd46d1c3d",
"resourceMappings": [ 
      {
         "appRegistryAppName": "MyWebApp",
         "mappingType": "AppRegistryApp",
         "physicalResourceId": {
            "identifier": "arn:aws:servicecatalog:us-west-2:444455556666:/applications/123456789012abcdefghijklmnop",
            "type": "ARN"
         },
      }
   ]
}
```

### Sample AppRegistry Response
<a name="API_AddDraftAppVersionResourceMappings_Example_6"></a>

The following is an example response payload.

#### Sample Response
<a name="API_AddDraftAppVersionResourceMappings_Example_6_Response"></a>

```
{
  "appArn": "aws:resiliencehub:us-west-2:444455556666:app/4019253a-0c99-4d30-be32-b14dd46d1c3d",
  "resourceMappings": [
    {
      "appRegistryAppName": "MyWebApp",
      "mappingType": "AppRegistryApp",
      "physicalResourceId": {
        "identifier": "arn:aws:servicecatalog:us-west-2:444455556666:/applications/123456789012abcdefghijklmnop",
        "type": "Arn"
      }
    }
  ]
}
```

### Sample Amazon EKS Request
<a name="API_AddDraftAppVersionResourceMappings_Example_7"></a>

The following is an example request payload.

#### Sample Request
<a name="API_AddDraftAppVersionResourceMappings_Example_7_Request"></a>

```
{
"appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/98f97a67-228f-40b3-8b2b-29da919c68cc",
   "resourceMappings": [ 
      {
         "eksSourceName": "my-cluster/my-namespace",
         "mappingType": "EKS",
         "physicalResourceId": {
            "identifier": "arn:aws:eks:us-west-2:444455556666:cluster/my-cluster/my-namespace",
            "type": "Arn"
         },
      }
   ]
}
```

### Sample Amazon EKS Response
<a name="API_AddDraftAppVersionResourceMappings_Example_8"></a>

The following is an example response payload.

#### Sample Response
<a name="API_AddDraftAppVersionResourceMappings_Example_8_Response"></a>

```
{
"appArn": "arn:aws:resiliencehub:us-west-2:444455556666:app/98f97a67-228f-40b3-8b2b-29da919c68cc",
   "resourceMappings": [ 
      {
"eksSourceName": "my-cluster/my-namespace",
         "mappingType": "EKS",
         "physicalResourceId": {
"identifier": "arn:aws:eks:us-west-2:444455556666:cluster/my-cluster/my-namespace",
            "type": "Arn"
         },
      }
   ]
}
```

## See Also
<a name="API_AddDraftAppVersionResourceMappings_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/AddDraftAppVersionResourceMappings) 

# BatchUpdateRecommendationStatus
<a name="API_BatchUpdateRecommendationStatus"></a>

Enables you to include or exclude one or more operational recommendations.

## Request Syntax
<a name="API_BatchUpdateRecommendationStatus_RequestSyntax"></a>

```
POST /batch-update-recommendation-status HTTP/1.1
Content-type: application/json

{
   "appArn": "string",
   "requestEntries": [ 
      { 
         "appComponentId": "string",
         "entryId": "string",
         "excluded": boolean,
         "excludeReason": "string",
         "item": { 
            "resourceId": "string",
            "targetAccountId": "string",
            "targetRegion": "string"
         },
         "referenceId": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_BatchUpdateRecommendationStatus_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_BatchUpdateRecommendationStatus_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [appArn](#API_BatchUpdateRecommendationStatus_RequestSyntax) **   <a name="resiliencehub-BatchUpdateRecommendationStatus-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [requestEntries](#API_BatchUpdateRecommendationStatus_RequestSyntax) **   <a name="resiliencehub-BatchUpdateRecommendationStatus-request-requestEntries"></a>
Defines the list of operational recommendations that need to be included or excluded.  
Type: Array of [UpdateRecommendationStatusRequestEntry](API_UpdateRecommendationStatusRequestEntry.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 50 items.  
Required: Yes

## Response Syntax
<a name="API_BatchUpdateRecommendationStatus_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string",
   "failedEntries": [ 
      { 
         "entryId": "string",
         "errorMessage": "string"
      }
   ],
   "successfulEntries": [ 
      { 
         "appComponentId": "string",
         "entryId": "string",
         "excluded": boolean,
         "excludeReason": "string",
         "item": { 
            "resourceId": "string",
            "targetAccountId": "string",
            "targetRegion": "string"
         },
         "referenceId": "string"
      }
   ]
}
```

## Response Elements
<a name="API_BatchUpdateRecommendationStatus_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_BatchUpdateRecommendationStatus_ResponseSyntax) **   <a name="resiliencehub-BatchUpdateRecommendationStatus-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [failedEntries](#API_BatchUpdateRecommendationStatus_ResponseSyntax) **   <a name="resiliencehub-BatchUpdateRecommendationStatus-response-failedEntries"></a>
A list of items with error details about each item, which could not be included or excluded.  
Type: Array of [BatchUpdateRecommendationStatusFailedEntry](API_BatchUpdateRecommendationStatusFailedEntry.md) objects

 ** [successfulEntries](#API_BatchUpdateRecommendationStatus_ResponseSyntax) **   <a name="resiliencehub-BatchUpdateRecommendationStatus-response-successfulEntries"></a>
A list of items that were included or excluded.  
Type: Array of [BatchUpdateRecommendationStatusSuccessfulEntry](API_BatchUpdateRecommendationStatusSuccessfulEntry.md) objects

## Errors
<a name="API_BatchUpdateRecommendationStatus_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## Examples
<a name="API_BatchUpdateRecommendationStatus_Examples"></a>

### Sample request
<a name="API_BatchUpdateRecommendationStatus_Example_1"></a>

This example illustrates one usage of BatchUpdateRecommendationStatus.

```
{
  "appArn": "APP_ARN",
  "requestEntries": [
    {
      "entryId": "entry_num_1",
      "referenceId": "s3:alarm:health_4xx_errors_count:2020-04-01",
      "item": {
        "resourceId": "a-resource-id",
        "targetAccountId": "123456789012",
        "targetRegion": "us-west-2"
      },
      "excluded": true,
      "excludeReason": "AlreadyImplemented"
    },
    {
      "entryId": "entry_num_2",
      "referenceId": "s3:alarm:health_total_request_latency:2020-04-01",
      "item": {
        "resourceId": "a-resource-id",
        "targetAccountId": "123456789012",
        "targetRegion": "us-west-2"
      },
      "excluded": true
    }
  ]
}
```

### Sample response
<a name="API_BatchUpdateRecommendationStatus_Example_2"></a>

This example illustrates one usage of BatchUpdateRecommendationStatus.

```
{
  "appArn": "APP_ARN",
  "successfulEntries": [
    {
      "entryId": "entry_num_2",
      "referenceId": "s3:alarm:health_total_request_latency:2020-04-01",
      "item": {
        "resourceId": "a-resource-id",
        "targetAccountId": "123456789012",
        "targetRegion": "us-west-2"
      },
      "excluded": true
    },
    {
      "entryId": "entry_num_1",
      "referenceId": "s3:alarm:health_4xx_errors_count:2020-04-01",
      "item": {
        "resourceId": "a-resource-id",
        "targetAccountId": "123456789012",
        "targetRegion": "us-west-2"
      },
      "excluded": true,
      "excludeReason": "AlreadyImplemented"
    }
  ],
  "failedEntries": []
}
```

## See Also
<a name="API_BatchUpdateRecommendationStatus_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/BatchUpdateRecommendationStatus) 

# CreateApp
<a name="API_CreateApp"></a>

Creates an AWS Resilience Hub application. An AWS Resilience Hub application is a collection of AWS resources structured to prevent and recover AWS application disruptions. To describe a AWS Resilience Hub application, you provide an application name, resources from one or more AWS CloudFormation stacks, AWS Resource Groups, Terraform state files, AppRegistry applications, and an appropriate resiliency policy. In addition, you can also add resources that are located on Amazon Elastic Kubernetes Service (Amazon EKS) clusters as optional resources. For more information about the number of resources supported per application, see [Service quotas](https://docs.aws.amazon.com/general/latest/gr/resiliencehub.html#limits_resiliencehub).

After you create an AWS Resilience Hub application, you publish it so that you can run a resiliency assessment on it. You can then use recommendations from the assessment to improve resiliency by running another assessment, comparing results, and then iterating the process until you achieve your goals for recovery time objective (RTO) and recovery point objective (RPO).

## Request Syntax
<a name="API_CreateApp_RequestSyntax"></a>

```
POST /create-app HTTP/1.1
Content-type: application/json

{
   "assessmentSchedule": "string",
   "awsApplicationArn": "string",
   "clientToken": "string",
   "description": "string",
   "eventSubscriptions": [ 
      { 
         "eventType": "string",
         "name": "string",
         "snsTopicArn": "string"
      }
   ],
   "name": "string",
   "permissionModel": { 
      "crossAccountRoleArns": [ "string" ],
      "invokerRoleName": "string",
      "type": "string"
   },
   "policyArn": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateApp_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateApp_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [assessmentSchedule](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-assessmentSchedule"></a>
 Assessment execution schedule with 'Daily' or 'Disabled' values.   
Type: String  
Valid Values: `Disabled | Daily`   
Required: No

 ** [awsApplicationArn](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-awsApplicationArn"></a>
Amazon Resource Name (ARN) of AWS Resource Groups group that is integrated with an AppRegistry application. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: No

 ** [clientToken](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [description](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-description"></a>
The optional description for an app.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 500.  
Required: No

 ** [eventSubscriptions](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-eventSubscriptions"></a>
The list of events you would like to subscribe and get notification for. Currently, AWS Resilience Hub supports only **Drift detected** and **Scheduled assessment failure** events notification.  
Type: Array of [EventSubscription](API_EventSubscription.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 10 items.  
Required: No

 ** [name](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-name"></a>
Name of the application.  
Type: String  
Pattern: `[A-Za-z0-9][A-Za-z0-9_\-]{1,59}`   
Required: Yes

 ** [permissionModel](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-permissionModel"></a>
Defines the roles and credentials that AWS Resilience Hub would use while creating the application, importing its resources, and running an assessment.  
Type: [PermissionModel](API_PermissionModel.md) object  
Required: No

 ** [policyArn](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-policyArn"></a>
Amazon Resource Name (ARN) of the resiliency policy. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:resiliency-policy/`policy-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: No

 ** [tags](#API_CreateApp_RequestSyntax) **   <a name="resiliencehub-CreateApp-request-tags"></a>
Tags assigned to the resource. A tag is a label that you assign to an AWS resource. Each tag consists of a key/value pair.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[^\x00-\x1f\x22]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[^\x00-\x1f\x22]*`   
Required: No

## Response Syntax
<a name="API_CreateApp_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "app": { 
      "appArn": "string",
      "assessmentSchedule": "string",
      "awsApplicationArn": "string",
      "complianceStatus": "string",
      "creationTime": number,
      "description": "string",
      "driftStatus": "string",
      "eventSubscriptions": [ 
         { 
            "eventType": "string",
            "name": "string",
            "snsTopicArn": "string"
         }
      ],
      "lastAppComplianceEvaluationTime": number,
      "lastDriftEvaluationTime": number,
      "lastResiliencyScoreEvaluationTime": number,
      "name": "string",
      "permissionModel": { 
         "crossAccountRoleArns": [ "string" ],
         "invokerRoleName": "string",
         "type": "string"
      },
      "policyArn": "string",
      "resiliencyScore": number,
      "rpoInSecs": number,
      "rtoInSecs": number,
      "status": "string",
      "tags": { 
         "string" : "string" 
      }
   }
}
```

## Response Elements
<a name="API_CreateApp_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [app](#API_CreateApp_ResponseSyntax) **   <a name="resiliencehub-CreateApp-response-app"></a>
The created application returned as an object with details including compliance status, creation time, description, resiliency score, and more.  
Type: [App](API_App.md) object

## Errors
<a name="API_CreateApp_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_CreateApp_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/CreateApp) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/CreateApp) 

# CreateAppVersionAppComponent
<a name="API_CreateAppVersionAppComponent"></a>

Creates a new AppComponent in the AWS Resilience Hub application.

**Note**  
This API updates the AWS Resilience Hub application draft version. To use this AppComponent for running assessments, you must publish the AWS Resilience Hub application using the `PublishAppVersion` API.

## Request Syntax
<a name="API_CreateAppVersionAppComponent_RequestSyntax"></a>

```
POST /create-app-version-app-component HTTP/1.1
Content-type: application/json

{
   "additionalInfo": { 
      "string" : [ "string" ]
   },
   "appArn": "string",
   "clientToken": "string",
   "id": "string",
   "name": "string",
   "type": "string"
}
```

## URI Request Parameters
<a name="API_CreateAppVersionAppComponent_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateAppVersionAppComponent_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalInfo](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-additionalInfo"></a>
Currently, there is no supported additional information for AppComponents.  
Type: String to array of strings map  
Key Pattern: `\S{1,128}`   
Array Members: Minimum number of 1 item. Maximum number of 10 items.  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: No

 ** [appArn](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [clientToken](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [id](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-id"></a>
Identifier of the AppComponent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Required: No

 ** [name](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-name"></a>
Name of the AppComponent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Required: Yes

 ** [type](#API_CreateAppVersionAppComponent_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-request-type"></a>
Type of AppComponent. For more information about the types of AppComponent, see [Grouping resources in an AppComponent](https://docs.aws.amazon.com/resilience-hub/latest/userguide/AppComponent.grouping.html).  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Required: Yes

## Response Syntax
<a name="API_CreateAppVersionAppComponent_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string",
   "appComponent": { 
      "additionalInfo": { 
         "string" : [ "string" ]
      },
      "id": "string",
      "name": "string",
      "type": "string"
   },
   "appVersion": "string"
}
```

## Response Elements
<a name="API_CreateAppVersionAppComponent_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_CreateAppVersionAppComponent_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [appComponent](#API_CreateAppVersionAppComponent_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-response-appComponent"></a>
List of AppComponents that belong to this resource.  
Type: [AppComponent](API_AppComponent.md) object

 ** [appVersion](#API_CreateAppVersionAppComponent_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionAppComponent-response-appVersion"></a>
 AWS Resilience Hub application version.  
Type: String  
Pattern: `\S{1,50}` 

## Errors
<a name="API_CreateAppVersionAppComponent_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_CreateAppVersionAppComponent_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/CreateAppVersionAppComponent) 

# CreateAppVersionResource
<a name="API_CreateAppVersionResource"></a>

Adds a resource to the AWS Resilience Hub application and assigns it to the specified AppComponents. If you specify a new AppComponent, AWS Resilience Hub will automatically create the AppComponent.

**Note**  
This action has no effect outside AWS Resilience Hub.
This API updates the AWS Resilience Hub application draft version. To use this resource for running resiliency assessments, you must publish the AWS Resilience Hub application using the `PublishAppVersion` API.
To update application version with new `physicalResourceID`, you must call `ResolveAppVersionResources` API.
 AWS Resilience Hub blocks manual grouping and automatically groups certain resources based on their dependencies and configurations to prevent configuration errors and ensure accurate resilience assessment results. For more information, see [Managing Application Components](https://docs.aws.amazon.com/resilience-hub/latest/userguide/AppComponent.html).

## Request Syntax
<a name="API_CreateAppVersionResource_RequestSyntax"></a>

```
POST /create-app-version-resource HTTP/1.1
Content-type: application/json

{
   "additionalInfo": { 
      "string" : [ "string" ]
   },
   "appArn": "string",
   "appComponents": [ "string" ],
   "awsAccountId": "string",
   "awsRegion": "string",
   "clientToken": "string",
   "logicalResourceId": { 
      "eksSourceName": "string",
      "identifier": "string",
      "logicalStackName": "string",
      "resourceGroupName": "string",
      "terraformSourceName": "string"
   },
   "physicalResourceId": "string",
   "resourceName": "string",
   "resourceType": "string"
}
```

## URI Request Parameters
<a name="API_CreateAppVersionResource_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateAppVersionResource_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalInfo](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-additionalInfo"></a>
Currently, there is no supported additional information for resources.  
Type: String to array of strings map  
Key Pattern: `\S{1,128}`   
Array Members: Minimum number of 1 item. Maximum number of 10 items.  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: No

 ** [appArn](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [appComponents](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-appComponents"></a>
List of AppComponents that this resource belongs to. If an AppComponent is not part of the AWS Resilience Hub application, it will be added.  
Type: Array of strings  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Required: Yes

 ** [awsAccountId](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-awsAccountId"></a>
 AWS account that owns the physical resource.  
Type: String  
Pattern: `[0-9]{12}`   
Required: No

 ** [awsRegion](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-awsRegion"></a>
 AWS region that owns the physical resource.  
Type: String  
Pattern: `[a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]`   
Required: No

 ** [clientToken](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [logicalResourceId](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-logicalResourceId"></a>
Logical identifier of the resource.  
Type: [LogicalResourceId](API_LogicalResourceId.md) object  
Required: Yes

 ** [physicalResourceId](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-physicalResourceId"></a>
Physical identifier of the resource.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: Yes

 ** [resourceName](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-resourceName"></a>
Name of the resource.  
Type: String  
Pattern: `[A-Za-z0-9][A-Za-z0-9_\-]{1,59}`   
Required: No

 ** [resourceType](#API_CreateAppVersionResource_RequestSyntax) **   <a name="resiliencehub-CreateAppVersionResource-request-resourceType"></a>
Type of resource.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Required: Yes

## Response Syntax
<a name="API_CreateAppVersionResource_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string",
   "appVersion": "string",
   "physicalResource": { 
      "additionalInfo": { 
         "string" : [ "string" ]
      },
      "appComponents": [ 
         { 
            "additionalInfo": { 
               "string" : [ "string" ]
            },
            "id": "string",
            "name": "string",
            "type": "string"
         }
      ],
      "excluded": boolean,
      "logicalResourceId": { 
         "eksSourceName": "string",
         "identifier": "string",
         "logicalStackName": "string",
         "resourceGroupName": "string",
         "terraformSourceName": "string"
      },
      "parentResourceName": "string",
      "physicalResourceId": { 
         "awsAccountId": "string",
         "awsRegion": "string",
         "identifier": "string",
         "type": "string"
      },
      "resourceName": "string",
      "resourceType": "string",
      "sourceType": "string"
   }
}
```

## Response Elements
<a name="API_CreateAppVersionResource_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_CreateAppVersionResource_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionResource-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [appVersion](#API_CreateAppVersionResource_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionResource-response-appVersion"></a>
 AWS Resilience Hub application version.  
Type: String  
Pattern: `\S{1,50}` 

 ** [physicalResource](#API_CreateAppVersionResource_ResponseSyntax) **   <a name="resiliencehub-CreateAppVersionResource-response-physicalResource"></a>
Defines a physical resource. A physical resource is a resource that exists in your account. It can be identified using an Amazon Resource Name (ARN) or a Resilience Hub-native identifier.  
Type: [PhysicalResource](API_PhysicalResource.md) object

## Errors
<a name="API_CreateAppVersionResource_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_CreateAppVersionResource_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/CreateAppVersionResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/CreateAppVersionResource) 

# CreateRecommendationTemplate
<a name="API_CreateRecommendationTemplate"></a>

Creates a new recommendation template for the AWS Resilience Hub application.

## Request Syntax
<a name="API_CreateRecommendationTemplate_RequestSyntax"></a>

```
POST /create-recommendation-template HTTP/1.1
Content-type: application/json

{
   "assessmentArn": "string",
   "bucketName": "string",
   "clientToken": "string",
   "format": "string",
   "name": "string",
   "recommendationIds": [ "string" ],
   "recommendationTypes": [ "string" ],
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateRecommendationTemplate_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateRecommendationTemplate_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [assessmentArn](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-assessmentArn"></a>
Amazon Resource Name (ARN) of the assessment. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app-assessment/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [bucketName](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-bucketName"></a>
The name of the Amazon S3 bucket that will contain the recommendation template.  
Type: String  
Pattern: `[A-Za-z0-9][A-Za-z0-9_\-]{1,59}`   
Required: No

 ** [clientToken](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [format](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-format"></a>
The format for the recommendation template.    
CfnJson  
The template is CloudFormation JSON.  
CfnYaml  
The template is CloudFormation YAML.
Type: String  
Valid Values: `CfnYaml | CfnJson`   
Required: No

 ** [name](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-name"></a>
The name for the recommendation template.  
Type: String  
Pattern: `[A-Za-z0-9][A-Za-z0-9_\-]{1,59}`   
Required: Yes

 ** [recommendationIds](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-recommendationIds"></a>
Identifiers for the recommendations used to create a recommendation template.  
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 200 items.  
Pattern: `[0-9a-f]{8}-[0-9a-f]{4}-[0-5][0-9a-f]{3}-[089ab][0-9a-f]{3}-[0-9a-f]{12}`   
Required: No

 ** [recommendationTypes](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-recommendationTypes"></a>
An array of strings that specify the recommendation template type or types.    
Alarm  
The template is an [AlarmRecommendation](API_AlarmRecommendation.md) template.  
Sop  
The template is a [SopRecommendation](API_SopRecommendation.md) template.  
Test  
The template is a [TestRecommendation](API_TestRecommendation.md) template.
Type: Array of strings  
Array Members: Minimum number of 1 item. Maximum number of 4 items.  
Valid Values: `Alarm | Sop | Test`   
Required: No

 ** [tags](#API_CreateRecommendationTemplate_RequestSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-request-tags"></a>
Tags assigned to the resource. A tag is a label that you assign to an AWS resource. Each tag consists of a key/value pair.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[^\x00-\x1f\x22]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[^\x00-\x1f\x22]*`   
Required: No

## Response Syntax
<a name="API_CreateRecommendationTemplate_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "recommendationTemplate": { 
      "appArn": "string",
      "assessmentArn": "string",
      "endTime": number,
      "format": "string",
      "message": "string",
      "name": "string",
      "needsReplacements": boolean,
      "recommendationIds": [ "string" ],
      "recommendationTemplateArn": "string",
      "recommendationTypes": [ "string" ],
      "startTime": number,
      "status": "string",
      "tags": { 
         "string" : "string" 
      },
      "templatesLocation": { 
         "bucket": "string",
         "prefix": "string"
      }
   }
}
```

## Response Elements
<a name="API_CreateRecommendationTemplate_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [recommendationTemplate](#API_CreateRecommendationTemplate_ResponseSyntax) **   <a name="resiliencehub-CreateRecommendationTemplate-response-recommendationTemplate"></a>
The newly created recommendation template, returned as an object. This object includes the template's name, format, status, tags, Amazon S3 bucket location, and more.  
Type: [RecommendationTemplate](API_RecommendationTemplate.md) object

## Errors
<a name="API_CreateRecommendationTemplate_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_CreateRecommendationTemplate_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/CreateRecommendationTemplate) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/CreateRecommendationTemplate) 

# CreateResiliencyPolicy
<a name="API_CreateResiliencyPolicy"></a>

Creates a resiliency policy for an application.

**Note**  
 AWS Resilience Hub allows you to provide a value of zero for `rtoInSecs` and `rpoInSecs` of your resiliency policy. But, while assessing your application, the lowest possible assessment result is near zero. Hence, if you provide value zero for `rtoInSecs` and `rpoInSecs`, the estimated workload RTO and estimated workload RPO result will be near zero and the **Compliance status** for your application will be set to **Policy breached**.

## Request Syntax
<a name="API_CreateResiliencyPolicy_RequestSyntax"></a>

```
POST /create-resiliency-policy HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "dataLocationConstraint": "string",
   "policy": { 
      "string" : { 
         "rpoInSecs": number,
         "rtoInSecs": number
      }
   },
   "policyDescription": "string",
   "policyName": "string",
   "tags": { 
      "string" : "string" 
   },
   "tier": "string"
}
```

## URI Request Parameters
<a name="API_CreateResiliencyPolicy_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateResiliencyPolicy_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [dataLocationConstraint](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-dataLocationConstraint"></a>
Specifies a high-level geographical location constraint for where your resilience policy data can be stored.  
Type: String  
Valid Values: `AnyLocation | SameContinent | SameCountry`   
Required: No

 ** [policy](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-policy"></a>
The type of resiliency policy to be created, including the recovery time objective (RTO) and recovery point objective (RPO) in seconds.  
Type: String to [FailurePolicy](API_FailurePolicy.md) object map  
Valid Keys: `Software | Hardware | AZ | Region`   
Required: Yes

 ** [policyDescription](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-policyDescription"></a>
Description of the resiliency policy.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 500.  
Required: No

 ** [policyName](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-policyName"></a>
Name of the resiliency policy.  
Type: String  
Pattern: `[A-Za-z0-9][A-Za-z0-9_\-]{1,59}`   
Required: Yes

 ** [tags](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-tags"></a>
Tags assigned to the resource. A tag is a label that you assign to an AWS resource. Each tag consists of a key/value pair.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `[^\x00-\x1f\x22]+`   
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Value Pattern: `[^\x00-\x1f\x22]*`   
Required: No

 ** [tier](#API_CreateResiliencyPolicy_RequestSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-request-tier"></a>
The tier for this resiliency policy, ranging from the highest severity (`MissionCritical`) to lowest (`NonCritical`).  
Type: String  
Valid Values: `MissionCritical | Critical | Important | CoreServices | NonCritical | NotApplicable`   
Required: Yes

## Response Syntax
<a name="API_CreateResiliencyPolicy_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "policy": { 
      "creationTime": number,
      "dataLocationConstraint": "string",
      "estimatedCostTier": "string",
      "policy": { 
         "string" : { 
            "rpoInSecs": number,
            "rtoInSecs": number
         }
      },
      "policyArn": "string",
      "policyDescription": "string",
      "policyName": "string",
      "tags": { 
         "string" : "string" 
      },
      "tier": "string"
   }
}
```

## Response Elements
<a name="API_CreateResiliencyPolicy_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [policy](#API_CreateResiliencyPolicy_ResponseSyntax) **   <a name="resiliencehub-CreateResiliencyPolicy-response-policy"></a>
The type of resiliency policy that was created, including the recovery time objective (RTO) and recovery point objective (RPO) in seconds.  
Type: [ResiliencyPolicy](API_ResiliencyPolicy.md) object

## Errors
<a name="API_CreateResiliencyPolicy_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
This exception occurs when you have exceeded your service quota. To perform the requested action, remove some of the relevant resources, or use Service Quotas to request a service quota increase.  
HTTP Status Code: 402

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## Examples
<a name="API_CreateResiliencyPolicy_Examples"></a>

### Sample ResilienceHub ResiliencyPolicy
<a name="API_CreateResiliencyPolicy_Example_1"></a>

This example illustrates one usage of CreateResiliencyPolicy.

```
AWSTemplateFormatVersion: 2010-09-09
Resources:
  ResiliencyPolicyCFNCanaryStack:
    Type: AWS::ResilienceHub::ResiliencyPolicy
    Properties:
      PolicyName: "ResiliencyPolicyCFNCanaryExample"
      PolicyDescription: 'ResilienceHub TestResiliencyPolicy for CFN'
      Tier: 'MissionCritical'
      Tags:
        TagKey: ""
      Policy:
        Software:
          RtoInSecs: 10
          RpoInSecs: 10
        Hardware:
          RtoInSecs: 10
          RpoInSecs: 10
        AZ:
          RtoInSecs: 10
          RpoInSecs: 10
        Region:
          RtoInSecs: 10
          RpoInSecs: 10
```

## See Also
<a name="API_CreateResiliencyPolicy_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/CreateResiliencyPolicy) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/CreateResiliencyPolicy) 

# DeleteApp
<a name="API_DeleteApp"></a>

Deletes an AWS Resilience Hub application. This is a destructive action that can't be undone.

## Request Syntax
<a name="API_DeleteApp_RequestSyntax"></a>

```
POST /delete-app HTTP/1.1
Content-type: application/json

{
   "appArn": "string",
   "clientToken": "string",
   "forceDelete": boolean
}
```

## URI Request Parameters
<a name="API_DeleteApp_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DeleteApp_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [appArn](#API_DeleteApp_RequestSyntax) **   <a name="resiliencehub-DeleteApp-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [clientToken](#API_DeleteApp_RequestSyntax) **   <a name="resiliencehub-DeleteApp-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [forceDelete](#API_DeleteApp_RequestSyntax) **   <a name="resiliencehub-DeleteApp-request-forceDelete"></a>
A boolean option to force the deletion of an AWS Resilience Hub application.   
Type: Boolean  
Required: No

## Response Syntax
<a name="API_DeleteApp_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "appArn": "string"
}
```

## Response Elements
<a name="API_DeleteApp_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [appArn](#API_DeleteApp_ResponseSyntax) **   <a name="resiliencehub-DeleteApp-response-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

## Errors
<a name="API_DeleteApp_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_DeleteApp_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/DeleteApp) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/DeleteApp) 

# DeleteAppAssessment
<a name="API_DeleteAppAssessment"></a>

Deletes an AWS Resilience Hub application assessment. This is a destructive action that can't be undone.

## Request Syntax
<a name="API_DeleteAppAssessment_RequestSyntax"></a>

```
POST /delete-app-assessment HTTP/1.1
Content-type: application/json

{
   "assessmentArn": "string",
   "clientToken": "string"
}
```

## URI Request Parameters
<a name="API_DeleteAppAssessment_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DeleteAppAssessment_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [assessmentArn](#API_DeleteAppAssessment_RequestSyntax) **   <a name="resiliencehub-DeleteAppAssessment-request-assessmentArn"></a>
Amazon Resource Name (ARN) of the assessment. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app-assessment/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [clientToken](#API_DeleteAppAssessment_RequestSyntax) **   <a name="resiliencehub-DeleteAppAssessment-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

## Response Syntax
<a name="API_DeleteAppAssessment_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "assessmentArn": "string",
   "assessmentStatus": "string"
}
```

## Response Elements
<a name="API_DeleteAppAssessment_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [assessmentArn](#API_DeleteAppAssessment_ResponseSyntax) **   <a name="resiliencehub-DeleteAppAssessment-response-assessmentArn"></a>
Amazon Resource Name (ARN) of the assessment. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app-assessment/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [assessmentStatus](#API_DeleteAppAssessment_ResponseSyntax) **   <a name="resiliencehub-DeleteAppAssessment-response-assessmentStatus"></a>
The current status of the assessment for the resiliency policy.  
Type: String  
Valid Values: `Pending | InProgress | Failed | Success` 

## Errors
<a name="API_DeleteAppAssessment_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** ConflictException **   
This exception occurs when a conflict with a previous successful write is detected. This generally occurs when the previous write did not have time to propagate to the host serving the current request. A retry (with appropriate backoff logic) is the recommended response to this exception.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 409

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_DeleteAppAssessment_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/DeleteAppAssessment) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/DeleteAppAssessment) 

# DeleteAppInputSource
<a name="API_DeleteAppInputSource"></a>

Deletes the input source and all of its imported resources from the AWS Resilience Hub application.

## Request Syntax
<a name="API_DeleteAppInputSource_RequestSyntax"></a>

```
POST /delete-app-input-source HTTP/1.1
Content-type: application/json

{
   "appArn": "string",
   "clientToken": "string",
   "eksSourceClusterNamespace": { 
      "eksClusterArn": "string",
      "namespace": "string"
   },
   "sourceArn": "string",
   "terraformSource": { 
      "s3StateFileUrl": "string"
   }
}
```

## URI Request Parameters
<a name="API_DeleteAppInputSource_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DeleteAppInputSource_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [appArn](#API_DeleteAppInputSource_RequestSyntax) **   <a name="resiliencehub-DeleteAppInputSource-request-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}`   
Required: Yes

 ** [clientToken](#API_DeleteAppInputSource_RequestSyntax) **   <a name="resiliencehub-DeleteAppInputSource-request-clientToken"></a>
Used for an idempotency token. A client token is a unique, case-sensitive string of up to 64 ASCII characters. You should not reuse the same client token for other API requests.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 63.  
Pattern: `[A-Za-z0-9_.-]{0,63}`   
Required: No

 ** [eksSourceClusterNamespace](#API_DeleteAppInputSource_RequestSyntax) **   <a name="resiliencehub-DeleteAppInputSource-request-eksSourceClusterNamespace"></a>
The namespace on your Amazon Elastic Kubernetes Service cluster that you want to delete from the AWS Resilience Hub application.  
Type: [EksSourceClusterNamespace](API_EksSourceClusterNamespace.md) object  
Required: No

 ** [sourceArn](#API_DeleteAppInputSource_RequestSyntax) **   <a name="resiliencehub-DeleteAppInputSource-request-sourceArn"></a>
The Amazon Resource Name (ARN) of the imported resource you want to remove from the AWS Resilience Hub application. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Type: String  
[...]
